//
// Created by philipp on 03.04.18.
//

#include <NetworkingLib/Networking.h>
#include "../include/PlatoonProtocolLib/Protocol.h"
#include "../include/PlatoonProtocolLib/LeaderVehicle.h"

int main(int argc, char ** argv)
{
    using namespace platoonProtocol;

    if (argc < 3)
    {
        std::cerr << "Too few arguments!\n";
        return -1;
    }

    networking::Networking net;

    auto vehicleId = static_cast<VehicleId>(atoi(argv[1]));
    std::string broadcastAddress{argv[2]};

    auto leader = LeaderVehicle::create(net, NetworkInfo{vehicleId, broadcastAddress});
    leader->setOnRunningPlatoonCallback([]{ std::cout << "Platoon is running!\n"; });
    leader->setOnLeavingPlatoonCallback([]{ std::cout << "Left platoon!\n"; });
    leader->createPlatoon();

    float ps = 0.0f, ipd = 0.0f;

    while (1)
    {
        leader->setPlatoonConfig(PlatoonConfig{ps, ipd});
        ps += 1.0f;
        ipd += 0.1f;
        sleep(1);
    }

    return 0;
}